package robo;

import java.io.BufferedOutputStream;
import java.io.DataOutputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;

/**
 * 
 * @author Ngo Van Luyen - IFI
 *
 * 1. GetData
 * 2. WriteRoadBin
 */
public class MakeRoadBin {
	int Rnumber = 0; // total of road! How many road that I have?
	Road road = null;
	ArrayList<Road> roadList = null;
	
	public MakeRoadBin(){
		
	}
	public MakeRoadBin(ArrayList<Road> roadl){
		if (roadList != null) roadList.clear();
		roadList = roadl;
		Rnumber = roadList.size();
	}
	/**
	 * 
	 * * @param path : Path to road.bin, ex: bin/road.bin
	 * 
	 */

	public void WriteRoadBin(String path) {
		try {
			//DataOutputStream roadbin = new DataOutputStream(new FileOutputStream("bin/road.bin"));
			//DataOutputStream roadbin = new DataOutputStream(new FileOutputStream(path));
			DataOutputStream roadbin = new DataOutputStream(new BufferedOutputStream(new FileOutputStream(path)));
			tools.General.writeInt(roadbin, 0);// offset data
			tools.General.writeInt(roadbin, 0);
			tools.General.writeInt(roadbin, 0);// end offset data
			tools.General.writeInt(roadbin, Rnumber);// road number ; total of road; How many road that I have?
			System.out.println("Total road: " + Rnumber);
			for (int j = 0; j < Rnumber; j++) {
				road = (Road) roadList.get(j);
				tools.General.writeInt(roadbin, 17);// record ; size (4byte) of 1st record
				tools.General.writeInt(roadbin, road.getID());// roadID
				tools.General.writeInt(roadbin, road.getHID());
				tools.General.writeInt(roadbin, road.getTID());
				tools.General.writeInt(roadbin, road.getLength());
				tools.General.writeInt(roadbin, 0); //kind
				tools.General.writeInt(roadbin, 0); //cars to head
				tools.General.writeInt(roadbin, 0); //cars to tail
				tools.General.writeInt(roadbin, 0); //humans to head
				tools.General.writeInt(roadbin, 0); //humans to tail
				tools.General.writeInt(roadbin, tools.General.ROAD_WIDTH);// width of this road; AllWidth data = 8000
				tools.General.writeInt(roadbin, 0); //block
				tools.General.writeInt(roadbin, 0); //repair cost
				tools.General.writeInt(roadbin, 0); //median strip
				tools.General.writeInt(roadbin, 2);// lines to head
				tools.General.writeInt(roadbin, 2);// lines to tail
				tools.General.writeInt(roadbin, 0);// end of record

			}
			roadbin.flush();
			roadbin.close();

		} catch (FileNotFoundException e) {
			System.out.println("FileNotFoundException: " + e);
		} catch (IOException e) {
			System.out.println("IOException: " + e);
		}
	}
	
	public void makeEmptyRoadBin(String path) {
		try {
			DataOutputStream roadbin = new DataOutputStream(new BufferedOutputStream(new FileOutputStream(path)));
			tools.General.writeInt(roadbin, 0);// offset data
			tools.General.writeInt(roadbin, 0);
			tools.General.writeInt(roadbin, 0);// end offset data
			tools.General.writeInt(roadbin, 0);// road number ; total of road; How many road that I have?
			tools.General.writeInt(roadbin, 0);// record ; size (4byte) of 1st record
			roadbin.flush();
			roadbin.close();
		} catch (FileNotFoundException e) {
			System.out.println("FileNotFoundException: " + e);
		} catch (IOException e) {
			System.out.println("IOException: " + e);
		}
	}
	
	public ArrayList<Road> getRoadList(){
		return roadList;
	}
	
	public void setRoadList(ArrayList<Road> roadl){
		roadList = roadl;
		Rnumber = roadList.size();
	}
	
	public int getNumberOfRoad(){
		return Rnumber;
	}
}
