package tools;

import java.awt.Point;
import java.util.ArrayList;

import robo.Building;
import robo.Node;
import robo.Road;

public class MapGenerator {
	// node's data
	ArrayList<Node> 	nodeList = new ArrayList<Node>();
	int					numberOfNode = 0;
	
	// Road's data
	ArrayList<Road> 	roadList = new ArrayList<Road>();
	int					numberOfRoad = 0;
	
	// Building's data
	ArrayList<Building> 	buildingList = new ArrayList<Building>();
	int						numberOfBuilding = 0;
	
	public void addRoad(int x1, int y1, int x2, int y2){
		numberOfNode++;
    	int headID = numberOfNode;
    	Node 	HeadNode = new Node(numberOfNode, x1, y1);
    	Node n1 = tools.General.isInNodeList(HeadNode, nodeList);
    	if (n1 == null){
    		nodeList.add(HeadNode);
    	} else {
    		numberOfNode--;
    		HeadNode = n1;
    	}
    	
    	 
    	numberOfNode++;
    	int tailID = numberOfNode;
    	Node 	TailNode = new Node(numberOfNode, x2, y2);
    	Node n2 = tools.General.isInNodeList(TailNode, nodeList);
    	if (n2 == null){
    		nodeList.add(TailNode);
    	} else {
    		numberOfNode--;
    		TailNode = n2;
    	}
    	
    	int roadLenght = tools.General.GetLength2Node(HeadNode, TailNode);
    	numberOfRoad++;
    	Road	road = new Road(numberOfRoad, headID, tailID, roadLenght);
    	roadList.add(road);
	}
	
	public void addBuilding(int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4){
		numberOfBuilding++;
    	Building building = new Building();
    	
    	int n = 4;
    	ArrayList<Point> inputArray = new ArrayList<Point>();
    	Point p1 = new Point(x1, y1);
    	inputArray.add(p1);
    	Point p2 = new Point(x2, y2);
    	inputArray.add(p2);
    	Point p3 = new Point(x3, y3);
    	inputArray.add(p3);
    	Point p4 = new Point(x4, y4);
    	inputArray.add(p4);

    	double 	cx, cy;	
    	building.fieryness = 0;
    	building.floorNum = 1;
    	building.id = numberOfBuilding;
    	building.nodeId = 0;
    	building.nodeLength = 0;
    	building.outlineX = new int[n];
    	building.outlineY = new int[n];
    	
    	double sumX=0, sumY=0;
		for(int i=0;i<n;i++){
			building.outlineX[i] = inputArray.get(i).x;
			building.outlineY[i] = inputArray.get(i).y;
			sumX += inputArray.get(i).x;
			sumY += inputArray.get(i).y;
		}
		cx = (int)(sumX/(inputArray.size()));
		cy = (int)(sumY/(inputArray.size()));
		building.cx = cx;
		building.cy = cy;
    	building.buildingArea = tools.BuildingTool.calcPolygonArea(building.outlineX, building.outlineY);
    	
    	buildingList.add(building);
	}
	
	public ArrayList<Node> getNodeList(){
		return nodeList;
	}
	
	public ArrayList<Road> getRoadList(){
		return roadList;
	}
	
	public ArrayList<Building> getBuildingList(){
		return buildingList;
	}
}
